space(G) :-
	statistics(runtime,[_,_]),
	G,
	statistics(runtime,[_,T4]),
	statistics(global_stack,[GS,_]),
	statistics(trail,[Trail,_]),
	statistics(garbage_collection,[GCs,_,_]),
	T is T4/1000,
	nl,
	write('Time: '), write(T),nl,
	write('Global stack: '), write(GS),nl,
	write('Trail: '), write(Trail),nl,
	write('No. of GCs: '), write(GCs),nl .
	
/* test(G,N) : run goal G N times, and prints runtime  */



test(G,N) :- 
	time(run(G,0,N),Tp),
	time(run(true,0,N),Td),
	Rtp is Tp - Td,
	write(time(Rtp)).

run(G,R,N) :- R < N, G, fail .
run(G,R,N) :- R < N, !, Rp1 is R + 1, run(G,Rp1,N) .
run(_,_,_) .

