q(a).
q(f(X)) :-
        q(X).

p(a).
p(f(X)) :-
        p(X),
        q(X).


%r(X).
r(f(f(f(a)))).
r(X) :-
        r(f(X)).

s(f(a)).
s(f(X)) :-
	r(X),
        s(X).

append([],X,X).
append([X|Xs],Ys,[X|Zs]) :-
	append(Xs,Ys,Zs).

rev([],[]).
rev([X|Xs],Ys) :-
	rev(Xs,Ys1),
	append(Ys1,[X],Ys).

rev([],L,L).
rev([X|Xs],Ys,Zs) :-
	rev(Xs,Ys,[X|Zs]).

crev(_,_).
crev(Xs,_) :- 
	crev([_|Xs],_).
capp(Ys1,[X|D],Ys) :-
	tnil(D),
	crev([X|Xs],Ys),
	arev(Xs,Ys1).
capp(Xs,Ys,Zs) :-
	capp([X|Xs],Ys,[X|Zs]).

tnil([]).

%capp([1,2,3],_,_).
arev([],[]) :-
	crev([],[]).
arev([X|Xs],Ys) :-
	crev([X|Xs],Ys),
	arev(Xs,Ys1),
	aapp(Ys1,[X],Ys).

aapp([],Ys,Ys) :-
	capp([],Ys,Ys).
aapp([X|Xs],Ys,[X|Zs]) :-
	capp([X|Xs],Ys,[X|Zs]),
	aapp(Xs,Ys,Zs).

l(a).
l(a(a)).
l(b(a)).
l(b(b)).
l(a(a(a))).
l(a(b(a))).
l(a(b(b))).
l(b(a(a))).
l(b(b(a))).

str([a]).
str([a,a]).
str([b,a]).
str([b,b]).
str([a,a,a]).
str([a,b,a]).
str([a,b,b]).
str([b,a,a]).
str([b,b,a]).

m(a).
m(f(X)) :- n(X).

n(a).
n(f(X)) :- k(X).
k(b).


ansmem(X,[X|Y]) :-
	qmem(X,[X|Y]).
ansmem(X,[Z|Y]) :-
	qmem(X,[Z|Y]),
	ansmem(X,Y).

qmem(X,Y) :-
	qmem(X,[_|Y]).
qmem(X,X).
